﻿using Volvo.CustomerMaster.Infrastructure.Common.Utilities.Repositories;
using Volvo.CustomerMaster.Customer.Model.Entities;
using Volvo.CustomerMaster.Customer.Model.RepositoryInterfaces;

using NHibernate;

namespace Volvo.CustomerMaster.Customer.Infrastructure.Repositories
{
    public class CustomerRepository : GenericRepository<Volvo.CustomerMaster.Customer.Model.Entities.Customer>, ICustomerRepository 
    {
        public Volvo.CustomerMaster.Customer.Model.Entities.Customer FindByCustomerNo(int customerNo)
        {
            IQuery q = Session.CreateQuery("from Customer where Number = :customerNo");
            q.SetInt32("customerNo", customerNo);
            return q.UniqueResult<Volvo.CustomerMaster.Customer.Model.Entities.Customer>();
        }

        public int GetMaxCustomerNumber()
        {
            IQuery q = Session.CreateQuery("select max(o.Number) from Customer o");
            return q.UniqueResult<int>();
        }      
    }
}
