﻿using System.Collections.Generic;
using Volvo.CustomerMaster.Customer.Model.Entities;
using Volvo.CustomerMaster.Infrastructure.Common.Utilities.Specifications;

namespace Volvo.CustomerMaster.Customer.Service
{
    /// <summary>
    /// Service interface for CustomerDomain component
    /// </summary>
    public interface ICustomerService
    {
        IList<Volvo.CustomerMaster.Customer.Model.Entities.Customer> Find(Specification<Volvo.CustomerMaster.Customer.Model.Entities.Customer> filterSpecification);
        IList<Volvo.CustomerMaster.Customer.Model.Entities.Customer> Find(Specification<Volvo.CustomerMaster.Customer.Model.Entities.Customer> filterSpecification, IEnumerable<SortSpecification<Volvo.CustomerMaster.Customer.Model.Entities.Customer>> sortSpecificationList);
        IList<Volvo.CustomerMaster.Customer.Model.Entities.Customer> Find(Specification<Volvo.CustomerMaster.Customer.Model.Entities.Customer> filterSpecification, IEnumerable<SortSpecification<Volvo.CustomerMaster.Customer.Model.Entities.Customer>> sortSpecificationList, int pageNumber, int pageSize);
        IList<T> Find<T>(Specification<Volvo.CustomerMaster.Customer.Model.Entities.Customer> filterSpecification, IEnumerable<SortSpecification<Volvo.CustomerMaster.Customer.Model.Entities.Customer>> sortSpecificationList, int pageNumber, int pageSize, GroupSpecification<Volvo.CustomerMaster.Customer.Model.Entities.Customer, T> groupSpecification);

        int Count();
        int Count(Specification<Volvo.CustomerMaster.Customer.Model.Entities.Customer> filterSpecification);
    }
}
