﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NHibernate;
using NHibernate.Tool.hbm2ddl;

namespace Volvo.CustomerMaster.Infrastructure.Common.Utilities.DbUtility
{
    public static class SchemaGenerator
    {
        public static void CreateDatabaseFromMapping()
        {
            //Start NHibernate
            NHibernate.Cfg.Configuration configuration = new NHibernate.Cfg.Configuration();
            configuration.Configure();
            ISessionFactory sessionFactory = configuration.BuildSessionFactory();

            //Create the database
            var schemaExport = new SchemaExport(configuration);
            schemaExport.Create(false, true);

            //Shut down NHibernate
            sessionFactory.Close();
        }

        public static void CreateDatabaseScriptFromMapping(string fileName)
        {
            //Start NHibernate
            NHibernate.Cfg.Configuration configuration = new NHibernate.Cfg.Configuration();
            configuration.Configure();
            ISessionFactory sessionFactory = configuration.BuildSessionFactory();

            //Create the database script
            var schemaExport = new SchemaExport(configuration);
            schemaExport.SetOutputFile(fileName).Execute(false, false, false);  

            //Shut down NHibernate
            sessionFactory.Close();
        }
    }
}
