﻿namespace Volvo.CustomerMaster.Infrastructure.Common.Utilities.Events
{
    /// <summary>
    /// A syncronous implementation of an eventpublisher. 
    /// </summary>
    /// <typeparam name="TEventType">Type of event</typeparam>
    public class EventPublisher<TEventType> : IEventPublisher<TEventType>
    {
        /// <summary>
        /// List of subscribers to the TEventType
        /// </summary>
        public IEventSubscriber<TEventType>[] Subscribers { get; set; }

        /// <summary>
        /// Publish of event to the list of subscribers
        /// </summary>
        /// <param name="e"></param>
        public void Publish(TEventType e)
        {
            if (Subscribers != null)
            {
                foreach (IEventSubscriber<TEventType> subscriber in Subscribers)
                {
                    subscriber.HandleEvent(e);
                }
            }
        }
    }
}
