﻿namespace Volvo.CustomerMaster.Infrastructure.Common.Utilities.Events
{
    /// <summary>
    /// Inteface to be implemented for a publisher of an event. 
    /// </summary>
    /// <typeparam name="EventType">Type of event</typeparam>
    public interface IEventPublisher<TEventType>
    {
        /// <summary>
        /// Array of subscribers of the event. Each subscriber have its own 
        /// implementation and thus one can be syncronous and an other asynchronous etc
        /// </summary>
        IEventSubscriber<TEventType>[] Subscribers { get; set; }

        /// <summary>
        /// Should publish events to all subscribers
        /// </summary>
        /// <param name="e"></param>
        void Publish(TEventType e);
    }
}
