﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NHibernate;
using System.Reflection;

namespace Volvo.CustomerMaster.Infrastructure.Common.Utilities.NamedQuery
{
    /// <summary>
    /// Helper class that sets the parameters for a named query with reflection.
    /// </summary>
    /// <typeparam name="TResult"></typeparam>
    public abstract class NamedQueryAutoSetParameters<TResult>: NamedQueryBase<TResult> 
    {
        protected override void SetParameters(NHibernate.IQuery nhQuery)
        {
            Type queryType = this.GetType();
            foreach (var propertyInfo in queryType.GetProperties(BindingFlags.Public | BindingFlags.Instance))
            {
                if (propertyInfo.Name != "QueryName" && propertyInfo.Name != "MaxResult")
                {
                    nhQuery.SetParameter(propertyInfo.Name, propertyInfo.GetValue(this, null));
                }
            }
        }
    }
}
