﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;
using System.Linq.Expressions;

namespace Volvo.CustomerMaster.Infrastructure.Common.Utilities.Specifications
{
    public class Group : IGrouping<object, object>
    {
        public IEnumerable Items { get; set; }
        public object Key { get; set; }
        public bool HasSubgroups { get; set; }

        public IEnumerator<object> GetEnumerator()
        {
            return (IEnumerator<object>)Items.GetEnumerator();
        }

        System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
        {
            return (System.Collections.IEnumerator)GetEnumerator();
        }

        public static IEnumerable<Group> BuildInnerGroup<T, TEntity>(IEnumerable<TEntity> group, Func<TEntity, T> groupSelector)
        {

            return group.GroupBy(groupSelector).Select(i => new Group
            {
                Key = i.Key,
                Items = i.ToList()
            });

        }

        public static Expression<Func<IEnumerable<TEntity>, IEnumerable<Group>>> BuildGroup<T, TEntity>(Func<TEntity, T> groupSelector, Expression<Func<IEnumerable<TEntity>, IEnumerable<Group>>> selectorBuilder)
        {
            var tempSelector = selectorBuilder;

            return g => g.GroupBy(groupSelector).Select(c => new Group
            {
                Key = c.Key,
                HasSubgroups = true,
                Items = tempSelector.Compile().Invoke(c).ToList()
            });
        }
    }
}
