﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Volvo.CustomerMaster.Infrastructure.Common.Utilities.Specifications
{
    /// <summary>
    /// Class to define the group condition of an entity.
    /// </summary>
    /// <typeparam name="T">Type of the Entity</typeparam>
    /// <typeparam name="TGroup">The return type of the group.</typeparam>
    public class GroupSpecification<T, TGroup> : SearchOptionSpecification<IEnumerable<T>, IEnumerable<TGroup>>
    {
        public override bool IsSatisfiedBy(IEnumerable<T> value)
        {
            return Predicate.Compile().Invoke(value) != null;
        }
    }
}
