﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Linq.Expressions;

namespace Volvo.CustomerMaster.Infrastructure.Common.Utilities.Specifications
{
    public class Specification<T> : AbstractSpecification<T>
    {

        public Specification() { }

        public Specification(Expression<Func<T, bool>> predicate)
        {
            this.Predicate = predicate;
        }

        public override Expression<Func<T, bool>> IsSatisfiedBy()
        {
            return this.Predicate;
        }

        public Expression<Func<T, bool>> Predicate { get; set; }
    }
}
