﻿using System.ServiceModel;
using NHibernate;

namespace Volvo.CustomerMaster.Infrastructure.Common.Utilities.WCF
{
    /// <summary>
    /// Putting an ISession into the InstanceContext requires to create a custom extension. 
    /// The extensions on the InstanceContext have a lifetime that lasts only for the duration of the WCF call
    /// </summary>
    public class NHibernateContextExtension : IExtension<InstanceContext>
    {
        public NHibernateContextExtension(ISession session)
        {
            Session = session;
        }

        public ISession Session { get; private set; }

        public void Attach(InstanceContext owner)
        {
        }

        public void Detach(InstanceContext owner)
        {
            Session.Flush();
        }
    }
}
