﻿using System.ServiceModel;
using System.ServiceModel.Dispatcher;
using System.ServiceModel.Channels;
using Volvo.CustomerMaster.Infrastructure.Common.Utilities.Repositories;

namespace Volvo.CustomerMaster.Infrastructure.Common.Utilities.WCF
{
    /// <summary>
    /// Attaches NHibernateContextExtension to each and every OperationContract call that is handled by our WCF service.
    /// </summary>
    public class NHibernateContextInitializer : IInstanceContextInitializer
    {
        public void Initialize(InstanceContext instanceContext, Message message)
        {
            instanceContext.Extensions.Add(
                new NHibernateContextExtension(
                    SessionProvider.GetSessionFactory().OpenSession()
                    )
                );
        }
    }
}
