﻿using Volvo.POS.UserDomain.ServiceLayer;
using Volvo.POS.UserDomain.DomainLayer.Entities;
using Volvo.POS.UserDomain.InfrastructureLayer.Proxies;
using System;
using Volvo.POS.UserDomain.DomainLayer.ValueObjects;
using Volvo.CustomerMaster.Infrastructure.Common.Utilities.Security;

namespace Volvo.POS.UserDomain.DomainLayer
{
    public class UserService : IUserService
    {        
        #region IUserService Members

        public User GetUser(string userName)
        {
             if (userName.Equals("", StringComparison.CurrentCultureIgnoreCase))
            {
                return null;
            }

            // 1. Check if user exists (in this mock we just create the user)
            User user = new User();
            user.UserVCN = userName;

            // 2. Get roles defined for the user
            if (userName.Equals("v0cn174", StringComparison.CurrentCultureIgnoreCase))
            {
                user.AddRole(new UserRole(UserRoleConstants.Administrator));
                //user.AddRole(new UserRole(UserRoleConstants.DataSteward));
                //user.AddRole(new UserRole(UserRoleConstants.User));
            }
            else
            {
                // All users are superusers in this mock
                user.AddRole(new UserRole(UserRoleConstants.Administrator));
                //user.AddRole(new UserRole(UserRoleConstants.DataSteward));
                //user.AddRole(new UserRole(UserRoleConstants.User));
            }
            return user;
        }

        #endregion
    }
}
