﻿using System.Web.Mvc;

namespace Volvo.CustomerMaster.Web.Common.Extensions
{
    public static class FlashMessageControllerExtension
    {
        /// <summary>
        /// queeues status message that should appear on page once and then disappear on reload.
        /// </summary>
        /// <param name="controller">The controller.</param>
        /// <param name="message">The message.</param>
        /// <param name="messageType">Type of the message.</param>
        public static void FlashMessage(this Controller controller, string message, MessageType messageType)
        {
            FlashMessenger messenger = (FlashMessenger)controller.HttpContext.Session[FlashMessenger.SessionKey];
            if (messenger == null)
            {
                messenger = new FlashMessenger();
                controller.HttpContext.Session[FlashMessenger.SessionKey] = messenger;
            }
            messenger.Messages[messageType].Enqueue(message);
        }

        /// <summary>
        /// queeues status message that should appear on page once and then disappear on reload.
        /// </summary>
        /// <param name="controller">The controller.</param>
        /// <param name="message">The message.</param>
        public static void FlashMessage(this Controller controller, string message)
        {
            FlashMessage(controller, message, MessageType.Info);
        }
    }
}
