﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web;
using System.Web.Mvc;

namespace Volvo.CustomerMaster.Web.Common.Extensions
{
    /// <summary>
    /// Class handling flashing messages displayed on page
    /// </summary>
    public class FlashMessenger
    {
        public const string ViewdataKey = "FlashMessenger";
        public const string SessionKey = "FlashMessenger";

        /// <summary>
        /// queued messages by type
        /// </summary>
        /// <value>The messages.</value>
        public Dictionary<MessageType, Queue<string>> Messages { get; private set; }

        /// <summary>
        /// Initializes a new instance of the <see cref="FlashMessenger"/> class.
        /// </summary>
        public FlashMessenger()
        {
            Messages = new Dictionary<MessageType, Queue<string>>();
            foreach (MessageType type in Enum.GetValues(typeof(MessageType)))
            {
                Messages[type] = new Queue<string>();
            }
        }
    }

    /// <summary>
    /// Flash Message type.
    /// </summary>
    public enum MessageType
    {
        Info = 1,
        Warning = 2,
        Error = 3
    };
}