﻿using System;
using System.Web.Mvc;

namespace Volvo.CustomerMaster.Web.Common.Helpers
{
    /// <summary>
    /// This class contain Volvo Custom HtmlHelper extensions for handling fields. 
    /// Import the namespace to your aspx-view and you will get these in intellicence 
    /// </summary>
    public static class InputControlsHelper
    {
        public static MvcHtmlString TextBox(this HtmlHelper helper, string name, DateTime value)
        {
           return System.Web.Mvc.Html.InputExtensions.TextBox(helper, name, String.Format("{0:d}", value));
        }

        public static MvcHtmlString TextBox(this HtmlHelper helper, string name,object  value, bool isEnabled)
        {
            if (isEnabled) //(viewMode == ViewMode.Edit)
            {
                return System.Web.Mvc.Html.InputExtensions.TextBox(helper, name,value);
            }
            else
            {
                return MvcHtmlString.Create(value.ToString() + System.Web.Mvc.Html.InputExtensions.Hidden(helper, name, value));
            }
        }
    }
}