﻿using System;
using System.Resources;
using Volvo.CustomerMaster.Infrastructure.Common.Utilities.ResourceManagement;

namespace Volvo.CustomerMaster.Web.Common.PresentationModelGenerics
{
    public class SelectableEnum<T> : ISelectableItem
    {
        public T EnumValue { get; set; }
        public string EnumText { get; set; }

        #region ISelectableItem Members
        public string Text
        {
            get { return EnumText; }
        }
        public string Value
        {
            get { return EnumValue.ToString(); }
        }
        #endregion

        public SelectableEnum(T value, ResourceManager localizationProvider)
        {
            EnumValue = value;
            EnumText = (localizationProvider == null)
                           ? Enum.GetName(typeof(T), value)
                           : localizationProvider.GetEnumValue(value);
        }
    }
}