﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Threading;
using System.Web;
using System.Web.Mvc;

namespace Volvo.CustomerMaster.Web.Common.Validation
{
    public class ModelClientValidationDataTimeRangeRule : ModelClientValidationRule
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ModelClientValidationDataTimeRangeRule"/> class.
        /// </summary>
        /// <param name="errorMessage">The error message.</param>
        /// <param name="minValue">The min value.</param>
        /// <param name="maxValue">The max value.</param>
        public ModelClientValidationDataTimeRangeRule(string errorMessage, DateTime minValue, DateTime maxValue)
        {
            ErrorMessage = errorMessage;
            ValidationType = "datetimerange";

            ValidationParameters["min"] = minValue.ToShortDateString();
            ValidationParameters["max"] = maxValue.ToShortDateString();
            ValidationParameters["dateformat"] = Thread.CurrentThread.CurrentCulture.DateTimeFormat.ShortDatePattern;
        }
    }
}