﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Volvo.CustomerMaster.Web.Common.Helpers;

namespace Volvo.CustomerMaster.Web.Controllers
{
    [HandleError]
    public class BaseController:Controller
    {
        protected override void ExecuteCore()
        {
            string cultureName = null;
            // Attempt to read the culture cookie from Request
            HttpCookie cultureCookie = Request.Cookies["_culture"];
            if (cultureCookie != null)
                cultureName = cultureCookie.Value;
            else
                // obtain it from HTTP header AcceptLanguages
                cultureName = Request.UserLanguages[0];

            // Validate culture name
            //cultureName = CultureHelper.GetImplementedCulture(cultureName);
            CultureHelper.SetCulture(cultureName);

            base.ExecuteCore();
        }

        protected override void OnException(ExceptionContext filterContext)
        {
            base.OnException(filterContext);
        }

    }
}