﻿using System.Web.Mvc;
using System.Web.Routing;
using Volvo.CustomerMaster.Web.Common.Extensions;
using Volvo.CustomerMaster.Web.Common.Helpers;
using Volvo.CustomerMaster.Web.Models;
using Volvo.CustomerMaster.Web.Common.Session;
using System;


namespace Volvo.CustomerMaster.Web.Controllers
{
    [HandleError]
    public class HomeController : BaseController
    {
        public ActionResult Index()
        {
            return View("Index");
        }

        public ActionResult About()
        {
            return View("About");
        }

        public ActionResult Help()
        {
            return View("Help");
        }        

        /// <summary>
        /// Sets the current layout theme (brand).
        /// </summary>
        /// <param name="id">The brand name.</param>
        /// <returns></returns>
        public ActionResult SetTheme(string id)
        {
            if (!string.IsNullOrEmpty(id))
            {
                ThemesHelper.SetCurrentTheme(id, HttpContext);
                this.FlashMessage(string.Format("Brand has been changed to  {0}", id), MessageType.Info);
            }
            return HttpContext.Request.UrlReferrer == null
                       ? (ActionResult)RedirectToAction("Index")
                       : Redirect(HttpContext.Request.UrlReferrer.AbsoluteUri);
        }

    }
}
