﻿using System;
using AutoMapper;
using Volvo.CustomerMaster.Infrastructure.Common.Utilities.Configuration;
using DomainCustomer = Volvo.CustomerMaster.Customer.Model.Entities;
using Volvo.CustomerMaster.Web.Models.Entities;


namespace Volvo.CustomerMaster.Web.Models.Translators
{
    public static class AutoMapperConfiguration
    {
        private static bool IsConfigured { get; set; }

        static AutoMapperConfiguration()
        {
            IsConfigured = false;
        }
        /// <summary>
        /// Configure all the mappings that need to be done using AutoMapper
        /// </summary>
        public static void Configure()
        {
            if (!IsConfigured)
            {
                Mapper.Initialize(cfg =>
                                      {
                                          // Mappings From Domain to UI
                                          cfg.CreateMap<Volvo.CustomerMaster.Customer.Model.Entities.Customer, Volvo.CustomerMaster.Web.Models.Entities.Customer>()
                                            .ForMember(dest => dest.Id , opt => opt.MapFrom(src => src.Id))
                                            .ForMember(dest => dest.Number, opt => opt.MapFrom(src => src.Number))
                                            .ForMember(dest => dest.Name, opt => opt.MapFrom(src => src.Name))
                                            .ForMember(dest => dest.Address, opt => opt.MapFrom(src => src.Address));

                                          // Mappings From UI to domain
                                          cfg.CreateMap<Volvo.CustomerMaster.Web.Models.Entities.Customer, Volvo.CustomerMaster.Customer.Model.Entities.Customer>()
                                            .ForMember(dest => dest.Id, opt => opt.MapFrom(src => src.Id))
                                            .ForMember(dest => dest.Number, opt => opt.MapFrom(src => src.Number))
                                            .ForMember(dest => dest.Name, opt => opt.MapFrom(src => src.Name))
                                            .ForMember(dest => dest.Address, opt => opt.MapFrom(src => src.Address));                                  
                                      
                                      });
            }
            //IsConfigured = true;
        }
    }
}

 
