﻿(function ($) {

    // DateTimeRange Client Validator
    $.validator.addMethod('dateTimeRange', function (value, element, params) {
        if (!value) {
            return true; // not testing 'is required' here!
        }
        try {
            // parse the value from DatePicker
            var dateValue = $.telerik.datepicker.prototype.parse(value, $.telerik.cultureInfo.shortDate);
            
            // if can't convert
            if (dateValue == null) 
                return false;
        }
        catch (e) {
            return false;
        }

        return dateValue >= params.min && dateValue <= params.max;
    });

    $.validator.unobtrusive.adapters.add('datetimerange', ['min', 'max', 'dateformat'], function (options) {
        var params = {
            min: $.telerik.datepicker.prototype.parse(options.params.min, options.params.dateformat),
            max: $.telerik.datepicker.prototype.parse(options.params.max, options.params.dateformat),
        };

        options.rules['dateTimeRange'] = params;
        options.messages['dateTimeRange'] = options.message;
    });

    // CompareTo Client Validator
    $.validator.addMethod('compareTo', function (value, element, params) {
        // initialization code can go here.
        var $p1 = $('#' + params.p1);
        var $p2 = $('#' + params.p2);
        
        if ($p1.length == 0 || $p2.length == 0)
            return false;

        var p1Type = $.NVS.getDataType($p1.val());
        var p2Type = $.NVS.getDataType($p2.val());

        if (p1Type != p2Type || (p1Type != 1 && p1Type != 2))
            return false;

        var p1Value;
        var p2Value;

        switch (p1Type) {
            case 1:
                p1Value = parseFloat($p1.val());
                p2Value = parseFloat($p2.val());
                break;

            case 2:
                p1Value = $.telerik.datepicker.prototype.parse($p1.val(), $.telerik.cultureInfo.shortDate);
                p2Value = $.telerik.datepicker.prototype.parse($p2.val(), $.telerik.cultureInfo.shortDate);
                break;
        }
        
        //EqualTo = 0
        //LessThan = 1
        //GreaterThan = 2
        switch (params.operation) {
            case 0:
                if (p1Value == p2Value)
                    return true;
                break;
            
            case 1:
                if (p1Value < p2Value)
                    return true;
                break;

            case 2:
                if (p1Value > p2Value)
                    return true
                break;
        }
        
        return false;
    });

    $.validator.unobtrusive.adapters.add('compareTo', ['p1', 'p2', 'operation'], function (options) {
        var params = {
            p1: options.params.p1,
            p2: options.params.p2,
            operation: parseInt(options.params.operation)
        };

        options.rules['compareTo'] = params;
        options.messages['compareTo'] = options.message;
    });

}) (jQuery);
